"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Item = exports.ButtonStrip = exports.TinyButton = exports.TinyButtonStyles = exports.Button = exports.LinkButton = exports.ButtonStyles = undefined;

var _templateObject = _taggedTemplateLiteral(["\n  max-width: ", "px;\n\n  ", " ", " margin: 0 auto;\n  text-decoration: none;\n  text-align: center;\n  display: block;\n\n  background: ", ";\n  background: ", "\n    ", ";\n  color: ", " !important;\n  color: ", "\n    ", " !important;\n\n  ", " & svg > path {\n    stroke: ", ";\n  }\n\n  border-radius: ", "em;\n  padding: ", "em 0;\n  margin-top: ", "em;\n  margin-bottom: ", "em;\n  cursor: pointer;\n  user-select: none;\n\n  box-shadow: 0 1px 1px\n      ", ",\n    0 0 0 1px\n      ", ";\n\n  &:active {\n    background: ", " !important;\n    box-shadow: 0 0 ", " inset;\n    color: ", " !important;\n  }\n\n  ", ";\n"], ["\n  max-width: ", "px;\n\n  ", " ", " margin: 0 auto;\n  text-decoration: none;\n  text-align: center;\n  display: block;\n\n  background: ", ";\n  background: ", "\n    ", ";\n  color: ", " !important;\n  color: ", "\n    ", " !important;\n\n  ", " & svg > path {\n    stroke: ", ";\n  }\n\n  border-radius: ", "em;\n  padding: ", "em 0;\n  margin-top: ", "em;\n  margin-bottom: ", "em;\n  cursor: pointer;\n  user-select: none;\n\n  box-shadow: 0 1px 1px\n      ", ",\n    0 0 0 1px\n      ", ";\n\n  &:active {\n    background: ", " !important;\n    box-shadow: 0 0 ", " inset;\n    color: ", " !important;\n  }\n\n  ", ";\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n    width: 100vw;\n    max-width: 100vw;\n    border-radius: 0;\n    section & {\n      margin-left: -", "em;\n    }\n  "], ["\n    width: 100vw;\n    max-width: 100vw;\n    border-radius: 0;\n    section & {\n      margin-left: -", "em;\n    }\n  "]),
    _templateObject3 = _taggedTemplateLiteral(["\n  ", ";\n"], ["\n  ", ";\n"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  box-sizing: content-box;\n  background: inherit;\n  border-width: 0;\n  color: inherit;\n  user-select: none;\n  margin: inherit;\n  width: 100%;\n  outline: transparent;\n\n  &:-moz-focus-inner {\n    border: 0;\n    padding: 0;\n  }\n  ", ";\n"], ["\n  box-sizing: content-box;\n  background: inherit;\n  border-width: 0;\n  color: inherit;\n  user-select: none;\n  margin: inherit;\n  width: 100%;\n  outline: transparent;\n\n  &:-moz-focus-inner {\n    border: 0;\n    padding: 0;\n  }\n  ", ";\n"]),
    _templateObject5 = _taggedTemplateLiteral(["\n  padding: ", "em\n    ", "em;\n  width: 8em;\n  border-radius: ", "em;\n\n  ", ";\n"], ["\n  padding: ", "em\n    ", "em;\n  width: 8em;\n  border-radius: ", "em;\n\n  ", ";\n"]),
    _templateObject6 = _taggedTemplateLiteral(["\n\t\tright: 0;\n\t"], ["\n\t\tright: 0;\n\t"]),
    _templateObject7 = _taggedTemplateLiteral(["\n\t\tright: -", "em;\n\t"], ["\n\t\tright: -", "em;\n\t"]),
    _templateObject8 = _taggedTemplateLiteral(["\n  & > div {\n    display: flex;\n    margin: 0;\n  }\n  width: 10em;\n"], ["\n  & > div {\n    display: flex;\n    margin: 0;\n  }\n  width: 10em;\n"]),
    _templateObject9 = _taggedTemplateLiteral(["\n  margin: 0;\n\n  border-top-left-radius: ", ";\n  border-bottom-left-radius: ", ";\n\n  border-top-right-radius: ", ";\n  border-bottom-right-radius: ", ";\n\n  ", ";\n"], ["\n  margin: 0;\n\n  border-top-left-radius: ", ";\n  border-bottom-left-radius: ", ";\n\n  border-top-right-radius: ", ";\n  border-bottom-right-radius: ", ";\n\n  ", ";\n"]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } //
// tools

//
// styles


//
// NOTE: Button is much heavier than ButtonLink
// since it includes a loader SVG animation.
//
/**************************** MAIN BUTTON STYLES ******************************/
var ButtonStyles = exports.ButtonStyles = (0, _styledComponents.css)(_templateObject, function (props) {
  return props.theme.size.breakpoint.stops.min;
}, function (props) {
  return props.theme.size.font.auto;
}, function (props) {
  return props.theme.typography.title.auto;
}, function (props) {
  return props.theme.color.background();
}, function (props) {
  return props.inverse ? props.theme.color.foreground() : null;
}, function (props) {
  return props.branded ? props.theme.color.brand() : null;
}, function (props) {
  return props.theme.color.foreground();
}, function (props) {
  return props.inverse ? props.theme.color.background() : null;
}, function (props) {
  return props.branded ? props.theme.color.background() : null;
}, "" /* for non-coloured buttons the animation SVG should have a foreground-colored fill */, function (props) {
  return !props.inverse && !props.branded ? props.theme.color.foreground() : null;
}, function (props) {
  return props.theme.effects.borderRadius.small;
}, function (props) {
  return props.theme.size.block.spacing / 1.25;
}, function (props) {
  return props.theme.size.block.spacing;
}, function (props) {
  return props.theme.size.block.spacing;
}, function (props) {
  return props.theme.color.foreground(props.theme.opacity.least * 2);
}, function (props) {
  return props.theme.color.foreground(props.theme.opacity.least);
}, function (props) {
  return props.theme.color.foreground();
}, function (props) {
  return props.theme.color.foreground();
}, function (props) {
  return props.theme.color.background();
}, function (props) {
  return props.theme.size.breakpoint.max.xs(_templateObject2, function (props) {
    return props.theme.size.block.padding;
  });
});
//
// below line filter out prop "branded" that isn't recognized by Link component
var LinkButton = (0, _styledComponents2.default)(function (_ref) {
  var branded = _ref.branded,
      inverse = _ref.inverse,
      responsiveMobileOnly = _ref.responsiveMobileOnly,
      props = _objectWithoutProperties(_ref, ["branded", "inverse", "responsiveMobileOnly"]);

  var Link = props.linkComponent;

  var linkComponent = props.linkComponent,
      validProps = _objectWithoutProperties(props, ["linkComponent"]);

  return _react2.default.createElement(Link, validProps);
})(_templateObject3, ButtonStyles);
//
// export non-a/link version of the button
exports.LinkButton = LinkButton;
var Button = (0, _styledComponents2.default)(function (_ref2) {
  var branded = _ref2.branded,
      inverse = _ref2.inverse,
      responsiveMobileOnly = _ref2.responsiveMobileOnly,
      props = _objectWithoutProperties(_ref2, ["branded", "inverse", "responsiveMobileOnly"]);

  var Loader = props.loaderComponent || null;
  return _react2.default.createElement(
    "button",
    {
      className: props.className,
      style: props.style,
      onClick: props.onClick,
      disabled: props.loading
    },
    Loader && _react2.default.createElement(Loader, { style: props.loading ? null : { width: "0" } }),
    props.children
  );
})(_templateObject4, ButtonStyles);
//
/**************************** TINY BUTTON STYLES ******************************/
exports.Button = Button;
var TinyButtonStyles = (0, _styledComponents2.default)(function (_ref3) {
  var responsiveMobileOnly = _ref3.responsiveMobileOnly,
      followComposerCursor = _ref3.followComposerCursor,
      props = _objectWithoutProperties(_ref3, ["responsiveMobileOnly", "followComposerCursor"]);

  return _react2.default.createElement(LinkButton, props);
})(_templateObject5, function (props) {
  return props.theme.size.block.spacing / 5;
}, function (props) {
  return props.theme.size.block.spacing / 2;
}, function (props) {
  return props.theme.effects.borderRadius.small;
}, function (props) {
  return props.followComposerCursor && "\n  margin-top: 2px;\n  position: absolute;\n  z-index: " + (props.theme.layer.up - 1) + ";\n  right: -" + props.theme.size.block.padding + "em;\n  " + props.theme.size.breakpoint.max.m(_templateObject6) + " " + props.theme.size.breakpoint.max.s(_templateObject7, props.theme.size.block.spacing) + ";\n  ";
});
exports.TinyButtonStyles = TinyButtonStyles;
var TinyButton = exports.TinyButton = function TinyButton(props) {
  return _react2.default.createElement(
    TinyButtonStyles,
    props,
    props.children
  );
};
//
/**************************** BUTTON STRIP STYLES *****************************/
var ButtonStrip = exports.ButtonStrip = _styledComponents2.default.div(_templateObject8);
//
var tinyButtonBorderRadious = (0, _styledComponents.css)(_templateObject3, function (props) {
  return props.theme.effects.borderRadius.small;
});
//
var Item = (0, _styledComponents2.default)(function (_ref4) {
  var left = _ref4.left,
      right = _ref4.right,
      script = _ref4.script,
      props = _objectWithoutProperties(_ref4, ["left", "right", "script"]);

  return _react2.default.createElement(TinyButton, props);
})(_templateObject9, function (props) {
  return props.left ? tinyButtonBorderRadious + "em" : 0;
}, function (props) {
  return props.left ? tinyButtonBorderRadious + "em" : 0;
}, function (props) {
  return props.right ? tinyButtonBorderRadious + "em" : 0;
}, function (props) {
  return props.right ? tinyButtonBorderRadious + "em" : 0;
}, function (props) {
  return props.script ? "font-family: " + props.theme.typography.text.font + " !important;font-weight: 400 !important;" : null;
});
exports.Item = Item;